;Brush, Mesh, Surface
Local mazeBrush = LoadBrush("blood\blood.png", 1+(VRAM*256))
Local mazeMesh = CreateMesh()
Local mazeSurface = CreateSurface(mazeMesh, mazeBrush)

;Temporres
Local tmpTurn
Local tmpX0#, tmpX1#, tmpX2#, tmpX3#, tmpY0#, tmpY1#, tmpY2#, tmpY3#
Local tmp0, tmp1, tmp2, tmp3

;Erstellen
For x = 0 To 29
	For y = 0 To 29
		If getMazePlus(x, y) > 0 Then
			tmpTurn = getTurn(x, y)
			If tmpTurn > 0 Then
				Select tmpTurn
					Case 1
						tmpX0 = 0.25: tmpY0 = 0.0
						tmpX1 = 0.5: tmpY1 = 0.0
						tmpX2 = 0.25: tmpY2 = 0.25
						tmpX3 = 0.5: tmpY3 = 0.25
					Case 2
						tmpX0 = 0.25: tmpY0 = 0.25
						tmpX1 = 0.25: tmpY1 = 0.0
						tmpX2 = 0.5: tmpY2 = 0.25
						tmpX3 = 0.5: tmpY3 = 0.0
					Case 3
						tmpX0 = 0.25: tmpY0 = 0.25
						tmpX1 = 0.5: tmpY1 = 0.25
						tmpX2 = 0.25: tmpY2 = 0.0
						tmpX3 = 0.5: tmpY3 = 0.0
					Case 4
						tmpX0 = 0.5: tmpY0 = 0.0
						tmpX1 = 0.5: tmpY1 = 0.25
						tmpX2 = 0.25: tmpY2 = 0.0
						tmpX3 = 0.25: tmpY3 = 0.25
					Case 5
						tmpX0 = 0.0: tmpY0 = 0.75
						tmpX1 = 0.25: tmpY1 = 0.75
						tmpX2 = 0.0: tmpY2 = 1
						tmpX3 = 0.25: tmpY3 = 1
					Case 6
						tmpX0 = 0.0: tmpY0 = 1
						tmpX1 = 0.0: tmpY1 = 0.75
						tmpX2 = 0.25: tmpY2 = 1
						tmpX3 = 0.25: tmpY3 = 0.75
					Case 7
						tmpX0 = 0.0: tmpY0 = 0.0
						tmpX1 = 0.25: tmpY1 = 0.0
						tmpX2 = 0.0: tmpY2 = 0.25
						tmpX3 = 0.25: tmpY3 = 0.25
					Case 8
						tmpX0 = 0.0: tmpY0 = 0.25
						tmpX1 = 0.25: tmpY1 = 0.25
						tmpX2 = 0.0: tmpY2 = 0.0
						tmpX3 = 0.25: tmpY3 = 0.0
					Case 9
						tmpX0 = 0.25: tmpY0 = 0.25
						tmpX1 = 0.0: tmpY1 = 0.25
						tmpX2 = 0.25: tmpY2 = 0.0
						tmpX3 = 0.0: tmpY3 = 0.0
					Case 10
						tmpX0 = 0.25: tmpY0 = 0.0
						tmpX1 = 0.0: tmpY1 = 0.0
						tmpX2 = 0.25: tmpY2 = 0.25
						tmpX3 = 0.0: tmpY3 = 0.25
					Case 11
						tmpX0 = 0.0: tmpY0 = 0.5
						tmpX1 = 0.25: tmpY1 = 0.5
						tmpX2 = 0.0: tmpY2 = 0.25
						tmpX3 = 0.25: tmpY3 = 0.25
					Case 12
						tmpX0 = 0.25: tmpY0 = 0.25
						tmpX1 = 0.25: tmpY1 = 0.5
						tmpX2 = 0.0: tmpY2 = 0.25
						tmpX3 = 0.0: tmpY3 = 0.5
					Case 13
						tmpX0 = 0.0: tmpY0 = 0.25
						tmpX1 = 0.25: tmpY1 = 0.25
						tmpX2 = 0.0: tmpY2 = 0.5
						tmpX3 = 0.25: tmpY3 = 0.5
					Case 14
						tmpX0 = 0.0: tmpY0 = 0.5
						tmpX1 = 0.0: tmpY1 = 0.25
						tmpX2 = 0.25: tmpY2 = 0.5
						tmpX3 = 0.25: tmpY3 = 0.25
					Case 15
						tmpX0 = 0.0: tmpY0 = 0.5
						tmpX1 = 0.25: tmpY1 = 0.5
						tmpX2 = 0.0: tmpY2 = 0.75
						tmpX3 = 0.25: tmpY3 = 0.75
				End Select
				
				tmp0 = AddVertex(mazeSurface, x*18+0, 0, y*18+0, tmpX0, tmpY0)
				tmp1 = AddVertex(mazeSurface, x*18+6, 0, y*18+0, tmpX1, tmpY1)
				tmp2 = AddVertex(mazeSurface, x*18+0, 0, y*18+6, tmpX2, tmpY2)
				tmp3 = AddVertex(mazeSurface, x*18+6, 0, y*18+6, tmpX3, tmpY3)
				
				AddTriangle mazeSurface, tmp2, tmp1, tmp0
				AddTriangle mazeSurface, tmp2, tmp3, tmp1
				
				If getMazePlus(x+1, y) > 0 Then
					tmp0 = AddVertex(mazeSurface, x*18+6,  0, y*18+0, 0.75, 0.0)
					tmp1 = AddVertex(mazeSurface, x*18+18, 0, y*18+0, 0.75, 1.0)
					tmp2 = AddVertex(mazeSurface, x*18+6,  0, y*18+6, 0.5, 0.0)
					tmp3 = AddVertex(mazeSurface, x*18+18, 0, y*18+6, 0.5, 1.0)
					
					AddTriangle mazeSurface, tmp2, tmp1, tmp0
					AddTriangle mazeSurface, tmp2, tmp3, tmp1
				EndIf
				
				If getMazePlus(x, y+1) > 0 Then
					tmp0 = AddVertex(mazeSurface, x*18+0, 0, y*18+6,  0.5, 0.0)
					tmp1 = AddVertex(mazeSurface, x*18+6, 0, y*18+6,  0.75, 0.0)
					tmp2 = AddVertex(mazeSurface, x*18+0, 0, y*18+18, 0.5, 1.0)
					tmp3 = AddVertex(mazeSurface, x*18+6, 0, y*18+18, 0.75, 1.0)
					
					AddTriangle mazeSurface, tmp2, tmp1, tmp0
					AddTriangle mazeSurface, tmp2, tmp3, tmp1
				EndIf
			EndIf
		EndIf
	Next
Next

;Update
UpdateNormals mazeMesh

;Maze-Wert herausfinden (erweitert)
Function getMazePlus(x, y)
	If x < 0 Or x > 29 Then Return 0
	If y < 0 Or y > 29 Then Return 0
	If maze(x, y) > 0 Then Return 1
	Return 0
End Function

;Kurvenart zurckgeben (SEHR bel programmiert)
Function getTurn(x, y)
	Local tmpU = getMazePlus(x, y-1)
	Local tmpR = getMazePlus(x+1, y)
	Local tmpD = getMazePlus(x, y+1)
	Local tmpL = getMazePlus(x-1, y)
	Local sum = tmpU+tmpR+tmpD+tmpL
	
	Select sum
		Case 0
			Return 0
		Case 1
			If tmpD = 1 Then
				Return 1
			ElseIf tmpL = 1 Then
				Return 2
			ElseIf tmpU = 1 Then
				Return 3
			Else
				Return 4
			EndIf
		Case 2
			If tmpR = 1 And tmpL = 1 Then
				Return 5
			ElseIf tmpU = 1 And tmpD = 1 Then
				Return 6
			ElseIf tmpU = 1 And tmpR = 1 Then
				Return 7
			ElseIf tmpR = 1 And tmpD = 1 Then
				Return 8
			ElseIf tmpD = 1 And tmpL = 1 Then
				Return 9
			Else
				Return 10
			EndIf
		Case 3
			If tmpU = 0 Then
				Return 11
			ElseIf tmpR = 0 Then
				Return 12
			ElseIf tmpD = 0 Then
				Return 13
			Else
				Return 14
			EndIf
		Case 4
			Return 15
	End Select
End Function