;Ganz gewiss sein, dass beendet wird
End



;Protagonistin in den Ausgangszustand bringen
.setPlayerStandard
	EntityType playerPiv1, 0
	PositionEntity playerPiv2, 0, +3, 0
	RotateEntity playerCam, 0, 0, 0
	CameraFogMode playerCam, 0
	CameraRange playerCam, 0.3, 300
	SetAnimTime playerMesh, 1
	EntityAlpha fadeSprite, 0
	MoveMouse GWidth/2, GHeight/2
Return



;Protagonistin mit Kollision versehen
.setPlayerCollision
	EntityType playerPiv1, 1
	EntityRadius playerPiv1, 1, 4
Return



;Tren
.buildDoors
	;Tr zum Raum
	roomSprite = CreateSprite()
	roomSprTex = LoadTexture("door\room.png", 1)
	EntityTexture roomSprite, roomSprTex
	ScaleSprite roomSprite, 2.5, 5
	SpriteViewMode roomSprite, 2
	PositionEntity roomSprite, (startX*18)+3, 5, (startY*18)+3
	If maze(startX, startY-1) = 2 Then RotateEntity roomSprite, 0, 0, 0
	If maze(startX-1, startY) = 2 Then RotateEntity roomSprite, 0, -90, 0
	If maze(startX, startY+1) = 2 Then RotateEntity roomSprite, 0, 180, 0
	If maze(startX+1, startY) = 2 Then RotateEntity roomSprite, 0, +90, 0
	MoveEntity roomSprite, 0, 0, 2
	
	;Tr in die Freiheit
	houseSprite = CreateSprite()
	houseSprTex = LoadTexture("door\house.png", 1)
	EntityTexture houseSprite, houseSprTex
	ScaleSprite houseSprite, 2.5, 5
	SpriteViewMode houseSprite, 2
	PositionEntity houseSprite, (endX*18)+3, 5, (endY*18)+3
	If maze(endX, endY-1) = 2 Then RotateEntity houseSprite, 0, 0, 0
	If maze(endX-1, endY) = 2 Then RotateEntity houseSprite, 0, -90, 0
	If maze(endX, endY+1) = 2 Then RotateEntity houseSprite, 0, 180, 0
	If maze(endX+1, endY) = 2 Then RotateEntity houseSprite, 0, +90, 0
	MoveEntity houseSprite, 0, 0, 2
Return



;Spieler bewegen, drehen und animieren
.movePlayer
	;Drehung
	TurnEntity playerCam, MouseYSpeed()*0.5, 0, 0
	tmpPitch = EntityPitch(playerCam)
	If tmpPitch > 56 Then tmpPitch = 56
	If tmpPitch < -60 Then tmpPitch = -60
	RotateEntity playerCam, tmpPitch, 0, 0
	
	playerWalking = 0
	tmpXSpeed = MouseXSpeed()
	If tmpXSpeed <> 0 Then
		TurnEntity playerPiv1, 0, tmpXSpeed*-0.6, 0
	EndIf
	
	MoveMouse GWidth/2, GHeight/2
	
	;Bewegung
	playerRunning = 1
	If KeyDown(42) Then playerRunning = 2.5
	
	If KeyDown(17) Then
		playerFrame = playerFrame + (0.14*playerRunning)
		playerWalking = 1
		MoveEntity playerPiv1, 0, 0, (0.35*playerRunning)
	ElseIf KeyDown(31) Then
		playerFrame = playerFrame - 0.14
		MoveEntity playerPiv1, 0, 0, -0.35
		playerWalking = 1
	EndIf
	If playerWalking = 0 Then
		;playerFrame = 1
		playerFrame = playerFrame+(tmpXSpeed/50.0)
		If playerFrame < 6 Then playerFrame = 7
		If playerFrame < 7 Then playerFrame = playerFrame + 2
		If playerFrame > 9 Then playerFrame = playerFrame - 2
		PositionEntity playerPiv2, 0, +3, 0
		tmpFrame = playerFrame
	ElseIf playerWalking = 1 Then
		If playerFrame > 7 Then playerFrame = 2
		If playerFrame > 6 Then playerFrame = playerFrame - 4
		If playerFrame < 2 Then playerFrame = playerFrame + 4
		PositionEntity playerPiv2, 0, 2.8-(Cos(playerFrame*180)*0.2), 0
	EndIf
	SetAnimTime playerMesh, playerFrame
	
	;Gravitation
	MoveEntity playerPiv1, 0, -0.5, 0
Return



;Richtiger-Pfad-Status aktuallisieren
.updatePathState
	If isRightPath(Floor((EntityX(playerPiv1)+6)/18), Floor((EntityZ(playerPiv1)+6)/18)) = 1 Then
		pathState = pathState + 0.01
		If pathState > 1 Then
			pathState = 1
		EndIf
	Else
		pathState = pathState - 0.005
		If pathState < 0 Then pathState = 0
	EndIf
Return

;Feuerton
.updatePathFire
	If pathState < 1 Then
		If ChannelPlaying(fireLoop) = 0 Then fireLoop = PlayMusic("sound\fire.ogg")
		ChannelVolume fireLoop, 1.0-pathState
	Else
		If ChannelPlaying(fireLoop) Then StopChannel fireLoop
	EndIf
Return



;Atmung
.updateBreath
	If ChannelPlaying(breathChannel) = 0 Then breathChannel = PlayMusic("sound\breath.ogg")
Return



;Auf dem richtigen Weg?
Function isRightPath(x, y)
	If x < 0 Or x > 29 Then Return 0
	If y < 0 Or y > 29 Then Return 0
	If maze(x, y) = 2 Then Return 1
	Return 0
End Function