Graphics3D 640, 480, 0, 2
SetBuffer BackBuffer()

sphere = CreateSphere()
PositionEntity sphere, 0, 5, 0

brush = CreateBrush(0, 255, 0)
mesh = CreateMesh()
surface = CreateSurface(mesh, brush)
v0 = AddVertex(surface, -2, 0, +2)
v1 = AddVertex(surface, +2, 0, +2)
v2 = AddVertex(surface, -2, 0, -2)
v3 = AddVertex(surface, +2, 0, -2)
AddTriangle(surface, v3, v2, v0)
AddTriangle(surface, v1, v3, v0)
UpdateNormals mesh

EntityType sphere, 1
EntityRadius sphere, 1
EntityType mesh, 2
Collisions 1, 2, 2, 2

camera = CreateCamera()
PositionEntity camera, 0, 2, -6

timer = CreateTimer(30)

Repeat
	If KeyDown(208) Then MoveEntity sphere, 0, -0.2, 0
	If KeyDown(200) Then MoveEntity sphere, 0, +0.2, 0
	
	UpdateWorld
	RenderWorld
	WaitTimer timer
	Flip
Until KeyDown(1)

End